=== debian/changelog ===
votca-csg (1.5-3) unstable; urgency=high

  * libvotca-csg-dev: Additionally set Breaks/Replaces on libvotca-csg3.
    (Closes: #921664)

 -- Nicholas Breen <nbreen@debian.org>  Thu, 07 Feb 2019 18:59:36 -0800

votca-csg (1.5-2) unstable; urgency=medium

  * Add missing B-D on libeigen3-dev.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 03 Feb 2019 19:41:04 -0800

votca-csg (1.5-1) unstable; urgency=medium

  * New upstream release.
    - Remove solvematlab-syntax.patch, incorporated upstream.
  * Adding myself to uploaders.
  * SONAME bump, rename *-csg4 to *-csg5.
  * Move man pages to libvotca-csg-dev, to allow coinstallability of
    different versions of the library; set Breaks/Replaces on the old
    version of libvotca-csg4 due to the file overlap.
  * Update Standards-Version to 4.3.0.
  * Set Rules-Requires-Root: no.
  * debian/patches/tutorial-script-shebang.path: apply leading shebang to
    two tutorial scripts in the LJ1-LJ2 directory.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 02 Feb 2019 14:25:56 -0800
